#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

#define LDOUBLE

typedef long double my_double;

void usage();

my_double
	a = -1.0,
	b = 4.0;

int N = 10;
int mod = 3;

my_double my_sin(my_double x) {return sin((double)x);}
my_double my_tan(my_double x) {return tan((double)x);}
my_double my_exp(my_double x) {return exp((double)x);}
my_double my_asin(my_double x) {return asin((double)x);}
my_double my_log(my_double x) {return log((double)x);}

my_double  (*f)(my_double)=my_sin;
char *fce_name = "sin";

my_double h;
my_double h_draw;

/* kubicke spliny, base */
my_double
B0(my_double t)
{
	return (1-t)*(1-t)*(1-t)/6.0;

} /* B0 */

my_double
B1(my_double t)
{
	return ( 1 + 3 * ( 1 - t ) +
                     3 * t * ( 1 - t ) * ( 1 - t )
               ) / 6.0;
} /* B1 */

my_double 
B2(my_double t)
{
	return ( 1 + 3 * t * t * ( 1 - t ) + 3 * t ) / 6.0 ; 
} /* B2 */

my_double
B3(my_double t)
{
	return t * t * t / 6.0;
} /* B3 */


int
xtoi(my_double x)
{
	return (int)floor((x - a) / h ) ;
} /* xtoi */

my_double 
s3(my_double x)
{
	int i;
	my_double xi;
	my_double t;

	i = xtoi(x);
	xi = a + h * i;
	t = (x - xi) / h;

#if 0
	printf("[i:%3i xi:%8lf t:%8lf\n",i, xi, t);
	printf("{%B0:%lf + B1:%lf +  B2:%lf + B3:%lf = %lf\n",
		B0(t),
		B1(t),
		B2(t),
		B3(t), B0(t)+B1(t)+B2(t)+B3(t));

#endif
	return
	(-f(xi - 2*h)/6.0 + 4.0/3.0 * f(xi - 1*h) - f(xi + 0*h) /6.0)*B0(t) +
	(-f(xi - 1*h)/6.0 + 4.0/3.0 * f(xi + 0*h) - f(xi + 1*h) /6.0)*B1(t) +
	(-f(xi + 0*h)/6.0 + 4.0/3.0 * f(xi + 1*h) - f(xi + 2*h) /6.0)*B2(t) +
	(-f(xi + 1*h)/6.0 + 4.0/3.0 * f(xi + 2*h) - f(xi + 3*h) /6.0)*B3(t);
	
} /* s */

void
chose_fce(char *name)
{
	fce_name = name;
	if( 0 == strcmp(name, "sin"))
	{
		f = my_sin;
	}
	else if( 0 == strcmp(name, "exp"))
	{
		f = my_exp;
	}
	else if( 0 == strcmp(name, "log"))
	{
		f = my_log;
	}
	else if( 0 == strcmp(name, "tan"))
	{
		f = my_tan;
	}
	else if( 0 == strcmp(name, "asin"))
	{
		f = my_asin;
	}
	else
	{
		usage();
		exit(-1);
	}
} /* chose_fce */

void
solve()
{
	my_double sx, fx;
	my_double x, xi;

	printf("#%s(<%Lf, %Lf> / %i) %s values\n", 
			fce_name, a, b, N,
			mod==0?"true":mod==1?"aproximated":mod==2?"delta":"all");

	for(x = a; x <= b; x += h_draw)
	{
		fx = f(x);
		sx = s3(x);
		xi = a + xtoi(x) * h;

		switch( mod ) {
		case 0:
			printf("%Lf %Lf\n", x, fx);
			break;
		case 1:
			printf("%Lf %Lf\n", x, sx);
			break;
		case 2:
			printf("%Lf %Lf\n", x, fx - sx);
			break;
		case 3:
#ifdef LDOUBLE
			printf("%Lf %Lf %Lf %Lf %Lf\n", x, fx, sx, fx - sx, xi);
#else
			printf("%f %f %f %f %f\n", x, fx, sx, fx - sx, xi);
#endif
			break;
		}

	}

} /* solve */



void
usage()
{
	printf(
"usage: sp [-f FCE] [-a A] [-b B] [-h N] [-d D]\n "
"           -f FCE     pouzita fce (sin, exp, tan,  asin, log) [sin]\n"
"           -a A -b B  interval <A, B>  [0,1]\n"
"           -h H       krok [.1]\n"
"           -d Draw    kontrolni krok pro kresleni [.01]\n"
"           -m Mod     0: f(x), 1: s(x), 2: f(x) - s(x) 3: all (+xi) [3]\n"
);
	
} /* usage */
int
main(int argc, char *argv[])
{
	int c;

	a = 0.0;
	b = 4.0;
	f = my_sin;
	h = .1;
	h_draw = .01;
	mod = 3;

	while(-1 != (c = getopt(argc, argv, "m:f:a:b:h:d:")))
	{
		switch(c) {
		case 'a':
			a = atof(optarg);
			break;
		case 'b':
			b = atof(optarg);
			break;
		case 'h':
			h = atof(optarg);
			break;
		case 'd':
			h_draw = atof(optarg);
			break;
		case 'f':
			chose_fce(optarg);
			break;
		case 'm':
			mod = atoi(optarg);
			break;
		default:
			usage();
			exit(-1);
		}
	}
	N = floor((b - a) / h) + 1;
	solve();
	return 0;
} /* main */

